//audio
%error = forceRequiredAddOn("Gamemode_Slayer");

if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Weapon_Splattershot - required add-on Gamemode_Slayer not found");
   return;
}
datablock AudioProfile(splattershot1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(splattershotHitSound)
{
   filename    = "./bulletHit.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("Splattershot",   '<bitmap:add-ons/Weapon_Gun/CI_gun> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> %1',0.2,1);

exec("./orange.cs");
exec("./green.cs");
exec("./purple.cs");
exec("./blue.cs");
exec("./rainbow.cs");

function splattershotRepaint(%this,%obj,%col,%fade,%pos,%normal)
{
    if(%col.getClassName() $= "fxDtsBrick" && %col.colorFxID == 0 && %col.getName() !$= "_nop")
    {
        if(%obj.sourceObject.getState() !$= "Dead") {
            if (isObject(%obj.sourceObject.client.getTeam()) != 1)
            {
                %col.setColor(%obj.sourceObject.client.currentcolor);
            }
            else
                %col.setColor(%obj.sourceObject.client.getTeam().color);
        }
    }
}

package splattershotCollision
{
    function splattershotOProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
    {
        splattershotRepaint(%this,%obj,%col,%fade,%pos,%normal);
        Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
    }
    function splattershotGProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
    {
        splattershotRepaint(%this,%obj,%col,%fade,%pos,%normal);
        Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
    }
    function splattershotPProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
    {
        splattershotRepaint(%this,%obj,%col,%fade,%pos,%normal);
        Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
    }
    function splattershotBProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
    {
        splattershotRepaint(%this,%obj,%col,%fade,%pos,%normal);
        Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
    }
    function splattershotRProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
    {
        splattershotRepaint(%this,%obj,%col,%fade,%pos,%normal);
        Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
    }
};

activatePackage(splattershotCollision);
